Index: palm/trunk/SOURCE/check_parameters.f90
===================================================================
--- palm/trunk/SOURCE/check_parameters.f90	(revision 3291)
+++ palm/trunk/SOURCE/check_parameters.f90	(revision 3294)
@@ -25,4 +25,8 @@
 ! -----------------
 ! $Id: check_parameters.f90 2520 2017-10-05 13:50:26Z gronemeier &
+! changes concerning modularization of ocean option,
+! init_vertical_profiles moved to separate file to avoid circular dependency
+! 
+! 2520 2017-10-05 13:50:26Z gronemeier
 ! Modularization of all bulk cloud physics code components
 ! 
@@ -669,4 +673,6 @@
     USE arrays_3d
 
+    USE basic_constants_and_equations_mod
+
     USE bulk_cloud_model_mod,                                                  &
         ONLY:  bulk_cloud_model, bcm_check_parameters, bcm_check_data_output,  &
@@ -676,13 +682,21 @@
         ONLY:  chem_boundary_conds, chem_check_data_output,                    &
                chem_check_data_output_pr, chem_species
+
     USE chem_modules
-    USE basic_constants_and_equations_mod
+
     USE control_parameters
+
     USE dvrp_variables
+
     USE grid_variables
+
     USE gust_mod,                                                              &
         ONLY: gust_check_data_output, gust_check_data_output_pr,               &
               gust_check_parameters, gust_module_enabled
+
+    USE kinds
+
     USE indices
+
     USE land_surface_model_mod,                                                &
         ONLY: lsm_check_data_output, lsm_check_data_output_pr,                 &
@@ -691,6 +705,4 @@
     USE lsf_nudging_mod,                                                       &
         ONLY:  lsf_nudging_check_parameters, lsf_nudging_check_data_output_pr
-
-    USE kinds
 
     USE model_1d_mod,                                                          &
@@ -706,6 +718,12 @@
                waterflux_output_unit, momentumflux_output_unit
 
+    USE ocean_mod,                                                             &
+        ONLY:  ocean_check_data_output, ocean_check_data_output_pr,            &
+               ocean_check_parameters
+
     USE particle_attributes
+
     USE pegrid
+
     USE plant_canopy_model_mod,                                                &
         ONLY:  pcm_check_data_output, pcm_check_parameters
@@ -715,23 +733,35 @@
 
     USE profil_parameter
+
     USE radiation_model_mod,                                                   &
         ONLY:  radiation, radiation_check_data_output,                         &
                radiation_check_data_output_pr, radiation_check_parameters
+
     USE spectra_mod,                                                           &
         ONLY:  calculate_spectra, spectra_check_parameters
+
     USE statistics
+
     USE subsidence_mod
+
     USE statistics
+
     USE synthetic_turbulence_generator_mod,                                    &
         ONLY:  stg_check_parameters
+
     USE transpose_indices
+
     USE turbulence_closure_mod,                                                &
         ONLY:  tcm_check_data_output, tcm_check_parameters
+
     USE urban_surface_mod,                                                     &
         ONLY:  usm_check_data_output, usm_check_parameters
+
     USE uv_exposure_model_mod,                                                 &
         ONLY:  uvem_check_data_output
+
     USE wind_turbine_model_mod,                                                &
         ONLY:  wtm_check_parameters
+
     USE vertical_nesting_mod,                                                  &
         ONLY:  vnested, vnest_check_parameters
@@ -1083,8 +1113,4 @@
 
 !
-!-- Check turbulence closure setup
-    CALL tcm_check_parameters
-
-!
 !-- Check approximation
     IF ( TRIM( approximation ) /= 'boussinesq'   .AND.                         &
@@ -1127,4 +1153,5 @@
        CALL message( 'check_parameters', 'PA0450', 1, 2, 0, 6, 0 )
     ENDIF
+!
 !-- Set flux input mode according to approximation if applicable
     IF ( TRIM( flux_input_mode ) == 'approximation-specific' )  THEN
@@ -1145,4 +1172,5 @@
        CALL message( 'check_parameters', 'PA0451', 1, 2, 0, 6, 0 )
     ENDIF
+!
 !-- Set flux output mode according to approximation if applicable
     IF ( TRIM( flux_output_mode ) == 'approximation-specific' )  THEN
@@ -1163,5 +1191,5 @@
 
 !
-!-- set the flux output units according to flux_output_mode
+!-- Set the flux output units according to flux_output_mode
     IF ( TRIM( flux_output_mode ) == 'kinematic' ) THEN
         heatflux_output_unit              = 'K m/s'
@@ -1174,23 +1202,9 @@
     ENDIF
 
+!
 !-- set time series output units for fluxes
     dots_unit(14:16) = heatflux_output_unit
     dots_unit(21)    = waterflux_output_unit
     dots_unit(19:20) = momentumflux_output_unit
-
-!
-!-- Check ocean setting
-    IF ( TRIM( coupling_mode ) == 'uncoupled'  .AND.                           &
-         TRIM( coupling_char ) == '_O' .AND.                                   &
-         .NOT. ocean )  THEN
-
-!
-!--    Check whether an (uncoupled) atmospheric run has been declared as an
-!--    ocean run (this setting is done via palmrun-option -y)
-       message_string = 'ocean = .F. does not allow coupling_char = "' //      &
-                        TRIM( coupling_char ) // '" set by palmrun-option "-y"'
-       CALL message( 'check_parameters', 'PA0317', 1, 2, 0, 6, 0 )
-
-    ENDIF
 
 !
@@ -1430,40 +1444,21 @@
 
 !
-!-- Check for synthetic turbulence generator settings
+!-- Check the module settings
+    IF ( ocean_mode )  CALL ocean_check_parameters
+    CALL tcm_check_parameters
     CALL stg_check_parameters
-!
-!-- When plant canopy model is used, peform addtional checks
-    IF ( plant_canopy )  CALL pcm_check_parameters
-
-!
-!-- Additional checks for spectra
-    IF ( calculate_spectra )  CALL spectra_check_parameters
-!
-!-- When land surface model is used, perform additional checks
-    IF ( land_surface )  CALL lsm_check_parameters
-!
-!-- When microphysics module is used, perform additional checks
-    IF ( bulk_cloud_model )  CALL bcm_check_parameters
-
-!
-!-- When urban surface model is used, perform additional checks
-    IF ( urban_surface )  CALL usm_check_parameters
-
-!
-!-- If wind turbine model is used, perform additional checks
-    IF ( wind_turbine )  CALL wtm_check_parameters
-!
-!-- When radiation model is used, peform addtional checks
-    IF ( radiation )  CALL radiation_check_parameters
-!
-!-- When gust module is used, perform additional checks
+    IF ( plant_canopy )         CALL pcm_check_parameters
+    IF ( calculate_spectra )    CALL spectra_check_parameters
+    IF ( land_surface )         CALL lsm_check_parameters
+    IF ( bulk_cloud_model )     CALL bcm_check_parameters
+    IF ( urban_surface )        CALL usm_check_parameters
+    IF ( wind_turbine )         CALL wtm_check_parameters
+    IF ( radiation )            CALL radiation_check_parameters
     IF ( gust_module_enabled )  CALL gust_check_parameters
-!
-!-- When large-scale forcing or nudging is used, peform addtional checks
     IF ( large_scale_forcing  .OR.  nudging )  CALL lsf_nudging_check_parameters
 
 !
-!-- In case of no model continuation run, check initialising parameters and
-!-- deduce further quantities
+!-- In case of no restart run, check initialising parameters and calculate
+!-- further quantities
     IF ( TRIM( initializing_actions ) /= 'read_restart_data' )  THEN
 
@@ -1472,5 +1467,4 @@
        pt_init = pt_surface
        IF ( humidity       )  q_init  = q_surface
-       IF ( ocean          )  sa_init = sa_surface
        IF ( passive_scalar )  s_init  = s_surface
        IF ( air_chemistry )  THEN
@@ -1486,5 +1480,5 @@
        gradient = 0.0_wp
 
-       IF (  .NOT.  ocean )  THEN
+       IF ( .NOT. ocean_mode )  THEN
 
           ug_vertical_gradient_level_ind(1) = 0
@@ -1550,5 +1544,5 @@
        gradient = 0.0_wp
 
-       IF (  .NOT.  ocean )  THEN
+       IF ( .NOT. ocean_mode )  THEN
 
           vg_vertical_gradient_level_ind(1) = 0
@@ -1691,23 +1685,12 @@
 !--    Compute initial chemistry profile using the given chemical species gradients
        IF ( air_chemistry )  THEN                                                          
-         DO lsp = 1, nvar
-          CALL init_vertical_profiles( cs_vertical_gradient_level_ind(lsp,:),  &
-                                       cs_vertical_gradient_level(lsp,:),      &
-                                       cs_vertical_gradient(lsp,:),            &
-                                       chem_species(lsp)%conc_pr_init,         &
-                                       cs_surface(lsp), bc_cs_t_val(lsp) )
-         ENDDO
-       ENDIF
-!
-!
-!--    If required, compute initial salinity profile using the given salinity
-!--    gradients
-       IF ( ocean )  THEN
-          CALL init_vertical_profiles( sa_vertical_gradient_level_ind,          &
-                                       sa_vertical_gradient_level,              &
-                                       sa_vertical_gradient, sa_init,           &
-                                       sa_surface, dum )
-       ENDIF
-
+          DO  lsp = 1, nvar
+            CALL init_vertical_profiles( cs_vertical_gradient_level_ind(lsp,:),&
+                                         cs_vertical_gradient_level(lsp,:),    &
+                                         cs_vertical_gradient(lsp,:),          &
+                                         chem_species(lsp)%conc_pr_init,       &
+                                         cs_surface(lsp), bc_cs_t_val(lsp) )
+          ENDDO
+       ENDIF
 
     ENDIF
@@ -1777,15 +1760,4 @@
                         TRIM( reference_state ) // '"'
        CALL message( 'check_parameters', 'PA0056', 1, 2, 0, 6, 0 )
-    ENDIF
-
-!
-!-- Sign of buoyancy/stability terms
-    IF ( ocean )  atmos_ocean_sign = -1.0_wp
-
-!
-!-- Ocean version must use flux boundary conditions at the top
-    IF ( ocean .AND. .NOT. use_top_fluxes )  THEN
-       message_string = 'use_top_fluxes must be .TRUE. in ocean mode'
-       CALL message( 'check_parameters', 'PA0042', 1, 2, 0, 6, 0 )
     ENDIF
 
@@ -2067,39 +2039,4 @@
 
 !
-!-- Boundary conditions for salinity
-    IF ( ocean )  THEN
-       IF ( bc_sa_t == 'dirichlet' )  THEN
-          ibc_sa_t = 0
-       ELSEIF ( bc_sa_t == 'neumann' )  THEN
-          ibc_sa_t = 1
-       ELSE
-          message_string = 'unknown boundary condition: bc_sa_t = "' //        &
-                           TRIM( bc_sa_t ) // '"'
-          CALL message( 'check_parameters', 'PA0068', 1, 2, 0, 6, 0 )
-       ENDIF
-
-       IF ( top_salinityflux == 9999999.9_wp )  constant_top_salinityflux = .FALSE.
-       IF ( ibc_sa_t == 1  .AND.  top_salinityflux == 9999999.9_wp )  THEN
-          message_string = 'boundary condition: bc_sa_t = "' //                &
-                           TRIM( bc_sa_t ) // '" requires to set ' //          &
-                           'top_salinityflux'
-          CALL message( 'check_parameters', 'PA0069', 1, 2, 0, 6, 0 )
-       ENDIF
-
-!
-!--    A fixed salinity at the top implies Dirichlet boundary condition for
-!--    salinity. In this case specification of a constant salinity flux is
-!--    forbidden.
-       IF ( ibc_sa_t == 0  .AND.  constant_top_salinityflux  .AND.             &
-            top_salinityflux /= 0.0_wp )  THEN
-          message_string = 'boundary condition: bc_sa_t = "' //                &
-                           TRIM( bc_sa_t ) // '" is not allowed with ' //      &
-                           'top_salinityflux /= 0.0'
-          CALL message( 'check_parameters', 'PA0070', 1, 2, 0, 6, 0 )
-       ENDIF
-
-    ENDIF
-
-!
 !-- Set boundary conditions for total water content
     IF ( humidity )  THEN
@@ -2158,5 +2095,5 @@
                .AND.  top_scalarflux /= 0.0_wp )  THEN
           message_string = 'boundary condition: bc_s_t = "' //                 &
-                           TRIM( bc_sa_t ) // '" is not allowed with ' //      &
+                           TRIM( bc_s_t ) // '" is not allowed with ' //       &
                            'top_scalarflux /= 0.0'
           CALL message( 'check_parameters', 'PA0441', 1, 2, 0, 6, 0 )
@@ -2230,5 +2167,5 @@
 
     IF ( rayleigh_damping_height == -1.0_wp )  THEN
-       IF (  .NOT.  ocean )  THEN
+       IF (  .NOT.  ocean_mode )  THEN
           rayleigh_damping_height = 0.66666666666_wp * zu(nzt)
        ELSE
@@ -2236,5 +2173,5 @@
        ENDIF
     ELSE
-       IF (  .NOT.  ocean )  THEN
+       IF (  .NOT.  ocean_mode )  THEN
           IF ( rayleigh_damping_height < 0.0_wp  .OR.                          &
                rayleigh_damping_height > zu(nzt) )  THEN
@@ -2519,22 +2456,4 @@
              hom(:,2,22,:) = SPREAD( zw, 2, statistic_regions+1 )
 
-          CASE ( 'sa', '#sa' )
-             IF ( .NOT. ocean )  THEN
-                message_string = 'data_output_pr = ' //                        &
-                                 TRIM( data_output_pr(i) ) // ' is not imp' // &
-                                 'lemented for ocean = .FALSE.'
-                CALL message( 'check_parameters', 'PA0091', 1, 2, 0, 6, 0 )
-             ELSE
-                dopr_index(i) = 23
-                dopr_unit(i)  = 'psu'
-                hom(:,2,23,:) = SPREAD( zu, 2, statistic_regions+1 )
-                IF ( data_output_pr(i)(1:1) == '#' )  THEN
-                   dopr_initial_index(i) = 26
-                   hom(:,2,26,:)         = SPREAD( zu, 2, statistic_regions+1 )
-                   hom(nzb,2,26,:)       = 0.0_wp    ! because zu(nzb) is negative
-                   data_output_pr(i)     = data_output_pr(i)(2:)
-                ENDIF
-             ENDIF
-
           CASE ( 'u*2' )
              dopr_index(i) = 30
@@ -2846,5 +2765,4 @@
              hom(:,2,57,:) = SPREAD( zu, 2, statistic_regions+1 )
 
-
           CASE ( 'u"pt"' )
              dopr_index(i) = 58
@@ -2876,58 +2794,4 @@
              dopr_unit(i)  = TRIM ( heatflux_output_unit )
              hom(:,2,63,:) = SPREAD( zu, 2, statistic_regions+1 )
-
-          CASE ( 'rho_ocean' )
-             IF (  .NOT.  ocean ) THEN
-                message_string = 'data_output_pr = ' //                        &
-                                 TRIM( data_output_pr(i) ) // ' is not imp' // &
-                                 'lemented for ocean = .FALSE.'
-                CALL message( 'check_parameters', 'PA0091', 1, 2, 0, 6, 0 )
-             ELSE
-                dopr_index(i) = 64
-                dopr_unit(i)  = 'kg/m3'
-                hom(:,2,64,:) = SPREAD( zu, 2, statistic_regions+1 )
-                IF ( data_output_pr(i)(1:1) == '#' )  THEN
-                   dopr_initial_index(i) = 77
-                   hom(:,2,77,:)         = SPREAD( zu, 2, statistic_regions+1 )
-                   hom(nzb,2,77,:)       = 0.0_wp    ! because zu(nzb) is negative
-                   data_output_pr(i)     = data_output_pr(i)(2:)
-                ENDIF
-             ENDIF
-
-          CASE ( 'w"sa"' )
-             IF (  .NOT.  ocean ) THEN
-                message_string = 'data_output_pr = ' //                        &
-                                 TRIM( data_output_pr(i) ) // ' is not imp' // &
-                                 'lemented for ocean = .FALSE.'
-                CALL message( 'check_parameters', 'PA0091', 1, 2, 0, 6, 0 )
-             ELSE
-                dopr_index(i) = 65
-                dopr_unit(i)  = 'psu m/s'
-                hom(:,2,65,:) = SPREAD( zw, 2, statistic_regions+1 )
-             ENDIF
-
-          CASE ( 'w*sa*' )
-             IF (  .NOT. ocean  ) THEN
-                message_string = 'data_output_pr = ' //                        &
-                                 TRIM( data_output_pr(i) ) // ' is not imp' // &
-                                 'lemented for ocean = .FALSE.'
-                CALL message( 'check_parameters', 'PA0091', 1, 2, 0, 6, 0 )
-             ELSE
-                dopr_index(i) = 66
-                dopr_unit(i)  = 'psu m/s'
-                hom(:,2,66,:) = SPREAD( zw, 2, statistic_regions+1 )
-             ENDIF
-
-          CASE ( 'wsa' )
-             IF (  .NOT.  ocean ) THEN
-                message_string = 'data_output_pr = ' //                        &
-                                 TRIM( data_output_pr(i) ) // ' is not imp' // &
-                                 'lemented for ocean = .FALSE.'
-                CALL message( 'check_parameters', 'PA0091', 1, 2, 0, 6, 0 )
-             ELSE
-                dopr_index(i) = 67
-                dopr_unit(i)  = 'psu m/s'
-                hom(:,2,67,:) = SPREAD( zw, 2, statistic_regions+1 )
-             ENDIF
 
           CASE ( 'w*p*' )
@@ -2953,16 +2817,4 @@
              ENDIF
 
-          CASE ( 'prho' )
-             IF (  .NOT.  ocean ) THEN
-                message_string = 'data_output_pr = ' //                        &
-                                 TRIM( data_output_pr(i) ) // ' is not imp' // &
-                                 'lemented for ocean = .FALSE.'
-                CALL message( 'check_parameters', 'PA0091', 1, 2, 0, 6, 0 )
-             ELSE
-                dopr_index(i) = 71
-                dopr_unit(i)  = 'kg/m3'
-                hom(:,2,71,:) = SPREAD( zu, 2, statistic_regions+1 )
-             ENDIF
-
           CASE ( 'hyp' )
              dopr_index(i) = 72
@@ -3014,20 +2866,34 @@
              ENDIF
 
-
-
           CASE DEFAULT
+
+!
+!--          Check for other modules
+             IF ( unit == 'illegal'  .AND.  bulk_cloud_model  )  THEN
+                CALL bcm_check_data_output_pr( data_output_pr(i), i, unit,     &
+                                               dopr_unit(i) )
+             ENDIF
+
+             IF ( unit == 'illegal' )  THEN
+                CALL chem_check_data_output_pr( data_output_pr(i), i, unit,    &
+                                                dopr_unit(i) )
+             ENDIF
+
+             IF ( unit == 'illegal'  .AND.  gust_module_enabled  )  THEN
+                CALL gust_check_data_output_pr( data_output_pr(i), i, unit,    &
+                                                dopr_unit(i) )
+             ENDIF
+
+             IF ( unit == 'illegal' )  THEN
+                CALL lsf_nudging_check_data_output_pr( data_output_pr(i), i,   &
+                                                       unit, dopr_unit(i) )
+             ENDIF
 
              CALL lsm_check_data_output_pr( data_output_pr(i), i, unit,        &
                                             dopr_unit(i) )
-!
-!--          Block of microphysics module profile outputs
-             IF ( unit == 'illegal'  .AND.  bulk_cloud_model  )  THEN
-                   CALL bcm_check_data_output_pr(data_output_pr(i), i, unit,   &
+
+             IF ( unit == 'illegal' )  THEN
+                CALL ocean_check_data_output_pr( data_output_pr(i), i, unit,   &
                                                  dopr_unit(i) )
-             ENDIF
-
-             IF ( unit == 'illegal' )  THEN
-                CALL lsf_nudging_check_data_output_pr( data_output_pr(i), i,   &
-                                                    unit, dopr_unit(i) )
              ENDIF
 
@@ -3036,16 +2902,7 @@
                                                      unit, dopr_unit(i) )
              ENDIF
-!
-!--          Block of gust module profile outputs
-             IF ( unit == 'illegal'  .AND.  gust_module_enabled  )  THEN
-                   CALL gust_check_data_output_pr( data_output_pr(i), i, unit, &
-                                                   dopr_unit(i) )
-             ENDIF
-
-             IF ( unit == 'illegal' )  THEN                                        
-                CALL chem_check_data_output_pr( data_output_pr(i), i,          &
-                                                unit, dopr_unit(i) )
-             ENDIF 
-
+
+!
+!--          Finally, check for user defined quantities
              IF ( unit == 'illegal' )  THEN
                 unit = ''
@@ -3053,4 +2910,6 @@
              ENDIF
 
+!
+!--          No valid quantity found
              IF ( unit == 'illegal' )  THEN
                 IF ( data_output_pr_user(1) /= ' ' )  THEN
@@ -3184,12 +3043,4 @@
              unit = 'kg/kg'
 
-          CASE ( 'rho_ocean' )
-             IF (  .NOT.  ocean )  THEN
-                message_string = 'output of "' // TRIM( var ) // '" requi' //  &
-                                 'res ocean = .TRUE.'
-                CALL message( 'check_parameters', 'PA0109', 1, 2, 0, 6, 0 )
-             ENDIF
-             unit = 'kg/m3'
-
           CASE ( 's' )
              IF (  .NOT.  passive_scalar )  THEN
@@ -3199,12 +3050,4 @@
              ENDIF
              unit = 'kg/m3'
-
-          CASE ( 'sa' )
-             IF (  .NOT.  ocean )  THEN
-                message_string = 'output of "' // TRIM( var ) // '" requi' //  &
-                                 'res ocean = .TRUE.'
-                CALL message( 'check_parameters', 'PA0109', 1, 2, 0, 6, 0 )
-             ENDIF
-             unit = 'psu'
 
           CASE ( 'p', 'pt', 'u', 'v', 'w' )
@@ -3279,28 +3122,12 @@
           CASE DEFAULT
 
-             CALL tcm_check_data_output ( var, unit )
-
-!
-!--          Block of microphysics module outputs
+             CALL tcm_check_data_output( var, unit )
+
+!
+!--          Check for other modules
              IF ( unit == 'illegal'  .AND.  bulk_cloud_model  )  THEN
-                CALL bcm_check_data_output ( var, unit )
-             ENDIF
-
-             IF ( unit == 'illegal' )  THEN
-                CALL lsm_check_data_output ( var, unit, i, ilen, k )
-             ENDIF
-
-             IF ( unit == 'illegal' )  THEN
-                CALL radiation_check_data_output( var, unit, i, ilen, k )
-             ENDIF
-
-!
-!--          Block of gust module outputs
-             IF ( unit == 'illegal'  .AND.  gust_module_enabled  )  THEN
-                CALL gust_check_data_output ( var, unit )
-             ENDIF
-
-!
-!--          Block of chemistry model outputs
+                CALL bcm_check_data_output( var, unit )
+             ENDIF
+
              IF ( unit == 'illegal'  .AND.  air_chemistry                      &
                                      .AND.  var(1:3) == 'kc_' )  THEN
@@ -3308,22 +3135,37 @@
              ENDIF
 
-!
-!--          Block of urban surface model outputs
-             IF ( unit == 'illegal' .AND. urban_surface .AND. var(1:4) == 'usm_' ) THEN
+             IF ( unit == 'illegal' )  THEN
+                CALL lsm_check_data_output ( var, unit, i, ilen, k )
+             ENDIF
+
+             IF ( unit == 'illegal'  .AND.  gust_module_enabled  )  THEN
+                CALL gust_check_data_output ( var, unit )
+             ENDIF
+
+             IF ( unit == 'illegal'  .AND.  ocean_mode )  THEN
+                CALL ocean_check_data_output( var, unit )
+             ENDIF
+
+             IF ( unit == 'illegal'  .AND.  plant_canopy                       &
+                                     .AND.  var(1:4) == 'pcm_' )  THEN
+                CALL pcm_check_data_output( var, unit )
+             ENDIF
+
+             IF ( unit == 'illegal' )  THEN
+                CALL radiation_check_data_output( var, unit, i, ilen, k )
+             ENDIF
+
+             IF ( unit == 'illegal'  .AND.  urban_surface                      &
+                                     .AND.  var(1:4) == 'usm_' )  THEN
                  CALL usm_check_data_output( var, unit )
              ENDIF
 
-!
-!--          Block of plant canopy model outputs
-             IF ( unit == 'illegal' .AND. plant_canopy .AND. var(1:4) == 'pcm_' ) THEN
-                 CALL pcm_check_data_output( var, unit )
-             ENDIF
-
-!
-!--          Block of uv exposure model outputs
-             IF ( unit == 'illegal' .AND. uv_exposure .AND. var(1:5) == 'uvem_' )  THEN
+             IF ( unit == 'illegal'  .AND.  uv_exposure                        &
+                                     .AND.  var(1:5) == 'uvem_' )  THEN
                 CALL uvem_check_data_output( var, unit, i, ilen, k )
              ENDIF
 
+!
+!--          Finally, check for user-defined quantities
              IF ( unit == 'illegal' )  THEN
                 unit = ''
@@ -3628,5 +3470,5 @@
 !-- Determine upper and lower hight level indices for random perturbations
     IF ( disturbance_level_b == -9999999.9_wp )  THEN
-       IF ( ocean )  THEN
+       IF ( ocean_mode )  THEN
           disturbance_level_b     = zu((nzt*2)/3)
           disturbance_level_ind_b = ( nzt * 2 ) / 3
@@ -3653,5 +3495,5 @@
 
     IF ( disturbance_level_t == -9999999.9_wp )  THEN
-       IF ( ocean )  THEN
+       IF ( ocean_mode )  THEN
           disturbance_level_t     = zu(nzt-3)
           disturbance_level_ind_t = nzt - 3
@@ -4074,106 +3916,4 @@
 
 
-
-!------------------------------------------------------------------------------!
-! Description:
-! ------------
-!> Inititalizes the vertical profiles of scalar quantities.
-!------------------------------------------------------------------------------!
-
-    SUBROUTINE init_vertical_profiles( vertical_gradient_level_ind,            &
-                                       vertical_gradient_level,                &
-                                       vertical_gradient,                      &
-                                       pr_init, surface_value, bc_t_val )
-
-
-       IMPLICIT NONE
-
-       INTEGER(iwp) ::  i     !< counter
-       INTEGER(iwp), DIMENSION(1:10) ::  vertical_gradient_level_ind !< vertical grid indices for gradient levels
-
-       REAL(wp)     ::  bc_t_val      !< model top gradient
-       REAL(wp)     ::  gradient      !< vertica gradient of the respective quantity
-       REAL(wp)     ::  surface_value !< surface value of the respecitve quantity
-
-
-       REAL(wp), DIMENSION(0:nz+1) ::  pr_init                 !< initialisation profile
-       REAL(wp), DIMENSION(1:10)   ::  vertical_gradient       !< given vertical gradient
-       REAL(wp), DIMENSION(1:10)   ::  vertical_gradient_level !< given vertical gradient level
-
-       i = 1
-       gradient = 0.0_wp
-
-       IF (  .NOT.  ocean )  THEN
-
-          vertical_gradient_level_ind(1) = 0
-          DO  k = 1, nzt+1
-             IF ( i < 11 )  THEN
-                IF ( vertical_gradient_level(i) < zu(k)  .AND.            &
-                     vertical_gradient_level(i) >= 0.0_wp )  THEN
-                   gradient = vertical_gradient(i) / 100.0_wp
-                   vertical_gradient_level_ind(i) = k - 1
-                   i = i + 1
-                ENDIF
-             ENDIF
-             IF ( gradient /= 0.0_wp )  THEN
-                IF ( k /= 1 )  THEN
-                   pr_init(k) = pr_init(k-1) + dzu(k) * gradient
-                ELSE
-                   pr_init(k) = pr_init(k-1) + dzu(k) * gradient
-                ENDIF
-             ELSE
-                pr_init(k) = pr_init(k-1)
-             ENDIF
-   !
-   !--       Avoid negative values
-             IF ( pr_init(k) < 0.0_wp )  THEN
-                pr_init(k) = 0.0_wp
-             ENDIF
-          ENDDO
-
-       ELSE
-
-          vertical_gradient_level_ind(1) = nzt+1
-          DO  k = nzt, 0, -1
-             IF ( i < 11 )  THEN
-                IF ( vertical_gradient_level(i) > zu(k)  .AND.            &
-                     vertical_gradient_level(i) <= 0.0_wp )  THEN
-                   gradient = vertical_gradient(i) / 100.0_wp
-                   vertical_gradient_level_ind(i) = k + 1
-                   i = i + 1
-                ENDIF
-             ENDIF
-             IF ( gradient /= 0.0_wp )  THEN
-                IF ( k /= nzt )  THEN
-                   pr_init(k) = pr_init(k+1) - dzu(k+1) * gradient
-                ELSE
-                   pr_init(k)   = surface_value - 0.5_wp * dzu(k+1) * gradient
-                   pr_init(k+1) = surface_value + 0.5_wp * dzu(k+1) * gradient
-                ENDIF
-             ELSE
-                pr_init(k) = pr_init(k+1)
-             ENDIF
-   !
-   !--       Avoid negative humidities
-             IF ( pr_init(k) < 0.0_wp )  THEN
-                pr_init(k) = 0.0_wp
-             ENDIF
-          ENDDO
-
-       ENDIF
-
-!
-!--    In case of no given gradients, choose zero gradient conditions
-       IF ( vertical_gradient_level(1) == -999999.9_wp )  THEN
-          vertical_gradient_level(1) = 0.0_wp
-       ENDIF
-!
-!--    Store gradient at the top boundary for possible Neumann boundary condition
-       bc_t_val  = ( pr_init(nzt+1) - pr_init(nzt) ) / dzu(nzt+1)
-
-    END SUBROUTINE init_vertical_profiles
-
-
-
 !------------------------------------------------------------------------------!
 ! Description:
